#ifndef LOCAL
#include <bits/stdc++.h>
#endif
using namespace std;
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")

#define int int64_t
const int inf=1e18;

#ifdef LOCAL
#include "algo/debug.h"
#else
template <typename... Args>
void dummy(Args&&... args){}
#define ps dummy
#endif

#define f first
#define s second
template<class T> using V = vector<T>; 
using vi = V<int>;
using vb = V<bool>;
using vs = V<string>;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x) 
#define len(x) (int)((x).size())
#define rsz resize
#define ins insert
#define ft front()
#define bk back()
#define pb push_back
#define eb emplace_back
#define pf push_front
#define lb lower_bound
#define ub upper_bound
#define ai2 array<int,2>
#define ai3 array<int,3>
#define ai4 array<int,4>
#define ai5 array<int,5>
template<class T> int lwb(const V<T>& a, const T& b) { return lb(all(a),b)-begin(a); }
template<class T> int upb(const V<T>& a, const T& b) { return ub(all(a),b)-begin(a); }
template<class T> bool ckmin(T& a, const T& b) { return a > b ? a=b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a=b, true : false; }
#define pct __builtin_popcountll
#define ctz __builtin_ctzll
#define clz __builtin_clzll
constexpr int p2(int x) { return (int)1 << x; }
constexpr int bits(int x) { return x == 0 ? 0 : 63-clz(x); } // floor(log2(x)) 
template<class T>void UNIQUE(V<T>& v) { sort(all(v)); v.erase(unique(all(v)),end(v)); }
template<class T,class U>void erase(T& t, const U& u) { auto it = t.find(u); assert(it != end(t)); t.erase(it); }
template<class F> struct y_combinator_result {
    F f;
    template<class T> explicit y_combinator_result(T &&f): f(std::forward<T>(f)) {}
    template<class ...Args> decltype(auto) operator()(Args &&...args) { return f(std::ref(*this), std::forward<Args>(args)...); }
};
template<class Fun> decltype(auto) yy(Fun &&fun) { return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun)); }

void solve() {
    int n, k; cin >> n >> k;

    vi a(n);
    for (int& i : a) cin >> i;
    int ans = 0;

    if (n <= 8) {
        vi b(n);
        yy([&](auto rec, int pos) -> void {
            if (pos == n) {
                vi times(k), ss_val(k);
                for (int i = 0; i < n; i++) {
                    times[b[i]]++;
                    ckmax(ss_val[b[i]], a[i] + times[b[i]]);
                }
                if (*min_element(all(times)) > 0) {
                    ckmax(ans, accumulate(all(ss_val), int(0)));
                }
                return;
            }
            
            for (int i = 0; i < k; i++) {
                b[pos] = i;
                rec(pos + 1);
            }

        })(0);

    } else if (k == 2){
        int mx = a[0];
        for (int i = 1; i < n; i++) {
            ckmax(ans, mx + a[i] + i + 1);
            ckmax(mx, a[i]);
        }
    } else {
        for (int i = 0; i < k - 1; i++) ans += a[i] + 1;
        int mx = 0;
        for (int i = 0; i < n - k + 1; i++) {
            ckmax(mx, a[i + k - 1] + i + 1);
        }
        ans += mx;
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
